'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _plugins = require('./plugins');

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**************************************************
 * Created by nanyuantingfeng on 29/10/2017 14:29.
 **************************************************/
exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(context, next) {
    var dll, plugins, DIRs, libraryName, dllPath, manifest, dllFileName;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            context.dll = false;

            next();

            dll = context.dll, plugins = context.plugins, DIRs = context.DIRs;
            libraryName = '[name]_[chunkhash]';

            if (Array.isArray(dll)) {
              plugins.push(new _plugins.DllPlugin({
                path: _path2.default.resolve(DIRs.build, 'manifest.json'),
                name: libraryName,
                context: context.context || context.cwd
              }));

              context.output = {
                path: DIRs.build,
                filename: libraryName + '.js',
                library: libraryName
              };

              context.entry = { dll: dll };
            }

            if (typeof dll === 'string' || dll === true) {
              dllPath = dll === true ? _path2.default.resolve(DIRs.root, 'dll') : dll;
              manifest = require(_path2.default.join(dllPath, 'manifest.json'));
              dllFileName = manifest.name + '.js';


              plugins.push(new _plugins.DllReferencePlugin({
                context: context.context || context.cwd,
                manifest: manifest
              }));

              plugins.push(new _plugins.CopyWebpackPlugin([{
                from: _path2.default.join(dllPath, dllFileName),
                to: DIRs.build
              }]));

              context.DLL_FILENAME = dllFileName;
            }

          case 6:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function (_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

module.exports = exports['default'];