'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _plugins = require('./plugins');

var _util = require('./util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(context, next) {
    var default_node_env, cwd, outputPath, env, isProduction, isDevelopment, isBeta, root, src, build;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            default_node_env = context.default_node_env, cwd = context.cwd, outputPath = context.outputPath;
            env = process.env.NODE_ENV || default_node_env || 'development';
            isProduction = env === 'production';
            isDevelopment = env === 'development';
            isBeta = env === 'beta';


            context.ENV = {
              isProduction: isProduction,
              isDevelopment: isDevelopment,
              isBeta: isBeta,
              env: env
            };

            root = cwd;
            src = _path2.default.resolve(root, 'src');
            build = _path2.default.resolve(root, outputPath);


            context.DIRs = {
              root: root, // 项目根目录
              cwd: root,
              src: src, // 项目业务代码根目录
              source: src,
              build: build, // 生成文件目录
              dist: build
            };

            context.packageMap = (0, _util.fnGetValueByPath)(_path2.default.join(cwd, 'package.json'));

            next();

            context.webpackConfig.plugins.push(new _plugins.DefinePlugin((0, _defineProperty3.default)({}, 'process.env.NODE_ENV', (0, _stringify2.default)(env))));

            return _context.abrupt('return', context);

          case 14:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function (_x, _x2) {
    return _ref.apply(this, arguments);
  };
}(); /**************************************************
      * Created by nanyuantingfeng on 27/10/2017 16:54.
      **************************************************/


module.exports = exports['default'];