'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _plugins = require('./plugins');

var _util = require('./util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**************************************************
 * Created by nanyuantingfeng on 24/08/2017 18:42.
 **************************************************/
exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(context, next) {
    var packageMap, plugins, ENV, version, versionTail;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            next();

            packageMap = context.packageMap, plugins = context.plugins, ENV = context.ENV;

            /***********************
             * copy文件到输出目录
             */

            plugins.push(new _plugins.CopyWebpackPlugin((0, _util.fnBuildCopyFiles)(context.files)));

            /***********************
             * 配置忽略依赖
             */
            context.externals = (0, _util.fnBuildExternals)(context.externals);

            version = context.version || packageMap.version || '0.0.0';
            versionTail = ENV.isBeta ? '-beta' : ENV.isDevelopment ? '-dev' : '';


            plugins.push(new _plugins.DefinePlugin((0, _extends3.default)({
              VERSION: (0, _stringify2.default)(version),
              APPLICATION_VERSION: (0, _stringify2.default)('v' + version + versionTail)
            }, context.defines)));

            plugins.push(new _plugins.ProvidePlugin(context.provides));

            /***********************
             * 多入口配置
             */
            (0, _util.fnBuildHTML)(context, ENV.env).forEach(function (line) {
              plugins.push(new _plugins.HTMLWebpackPlugin(line));
            });

          case 9:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function (_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

module.exports = exports['default'];